diff --git a/CMakeLists.txt b/CMakeLists.txt
index 7a9b241..49b0405 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -20,6 +20,7 @@ SET (GNUCXX_NO_MISMATCHED_TAGS_SUPPORT_VERSION "4.4")
 OPTION (MSGPACK_CXX11 "Using c++11 compiler" OFF)
 OPTION (MSGPACK_32BIT "32bit compile" OFF)
 OPTION (MSGPACK_BOOST "Using boost libraries" OFF)
+OPTION (MSGPACK_STATIC "Build static library" ON)
 
 SET (CMAKE_CXX_FLAGS "-DMSGPACK_DISABLE_LEGACY_NIL ${CMAKE_CXX_FLAGS}")
 SET (CMAKE_CXX_FLAGS "-DMSGPACK_DISABLE_LEGACY_CONVERT ${CMAKE_CXX_FLAGS}")
@@ -263,12 +264,14 @@ IF (MSGPACK_ENABLE_SHARED)
     )
 ENDIF ()
 
-ADD_LIBRARY (msgpackc-static STATIC
-    ${msgpackc_SOURCES}
-    ${msgpackc_HEADERS}
-)
+IF (MSGPACK_STATIC)
+    ADD_LIBRARY (msgpackc-static STATIC
+        ${msgpackc_SOURCES}
+        ${msgpackc_HEADERS}
+    )
+    SET_TARGET_PROPERTIES (msgpackc-static PROPERTIES OUTPUT_NAME "msgpackc")
+ENDIF()
 
-SET_TARGET_PROPERTIES (msgpackc-static PROPERTIES OUTPUT_NAME "msgpackc")
 IF (MSGPACK_ENABLE_SHARED)
     SET_TARGET_PROPERTIES (msgpackc PROPERTIES IMPORT_SUFFIX "_import.lib")
     SET_TARGET_PROPERTIES (msgpackc PROPERTIES SOVERSION 2 VERSION 2.0.0)
@@ -322,9 +325,10 @@ IF (MSGPACK_BUILD_EXAMPLES)
 ENDIF ()
 
 IF (MSGPACK_ENABLE_SHARED)
-    SET (MSGPACK_INSTALLTARGETS msgpackc msgpackc-static)
-ELSE()
-    SET (MSGPACK_INSTALLTARGETS msgpackc-static)
+    SET (MSGPACK_INSTALLTARGETS msgpackc)
+ENDIF()
+IF (MSGPACK_STATIC)
+    SET (MSGPACK_INSTALLTARGETS ${MSGPACK_INSTALLTARGETS} msgpackc-static)
 ENDIF ()
 
 INSTALL (TARGETS ${MSGPACK_INSTALLTARGETS} DESTINATION ${CMAKE_INSTALL_LIBDIR})
